using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Data.Divisions
{
    public class Header
    {
        #region Instance Data

        private string __head__;
        private int __version__;
        private int __filesize__;
        private int __indexOffset__;
        private int __indexSize__;
        private int __metaStart__;
        private int __metaSize__;
        private int __nonRawSize__;
        private string __origin__;
        private string __buildDate__;
        private int __mapTypeInt__;
        private Data.Types.MapTypes __mapType__;
        private int __strangeFileStringsSize__;
        private int __strangeFileStringsOffset__;
        private int __stringsOffset128__;
        private int __stringCount__;
        private int __stringsSize__;
        private int __stringsIndex__;
        private int __stringsOffset__;
        private string __internalName__;
        private string __scenarioName__;
        private int __fileTableCount__;
        private int __fileTableOffset__;
        private int __fileTableSize__;
        private int __fileTableIndexOffset__;
        private int __checksum__;
        private string __foot__;

        #endregion

        #region Accessors

        /// <summary>
        /// Head
        /// </summary>
        public string Head { get { return __head__; } set { __head__ = value; } }
        /// <summary>
        /// Version
        /// </summary>
        public int Version { get { return __version__; } set { __version__ = value; } }
        /// <summary>
        /// Filesize
        /// </summary>
        public int Filesize { get { return __filesize__; } set { __filesize__ = value; } }
        /// <summary>
        /// IndexOffset
        /// </summary>
        public int IndexOffset { get { return __indexOffset__; } set { __indexOffset__ = value; } }
        /// <summary>
        /// IndexSize
        /// </summary>
        public int IndexSize { get { return __indexSize__; } set { __indexSize__ = value; } }
        /// <summary>
        /// MetaStart
        /// </summary>
        public int MetaStart { get { return __metaStart__; } set { __metaStart__ = value; } }
        /// <summary>
        /// MetaSize
        /// </summary>
        public int MetaSize { get { return __metaSize__; } set { __metaSize__ = value; } }
        /// <summary>
        /// NonRawSize
        /// </summary>
        public int NonRawSize { get { return __nonRawSize__; } set { __nonRawSize__ = value; } }
        /// <summary>
        /// Origin
        /// </summary>
        public string Origin { get { return __origin__; } set { __origin__ = value; } }
        /// <summary>
        /// BuildDate
        /// </summary>
        public string BuildDate { get { return __buildDate__; } set { __buildDate__ = value; } }
        /// <summary>
        /// MapTypeInt
        /// </summary>
        public int MapTypeInt { get { return __mapTypeInt__; } set { __mapTypeInt__ = value; } }
        /// <summary>
        /// MapType
        /// </summary>
        public Data.Types.MapTypes MapType { get { return __mapType__; } set { __mapType__ = value; } }
        /// <summary>
        /// StrangeFileStringsSize
        /// </summary>
        public int StrangeFileStringsSize { get { return __strangeFileStringsSize__; } set { __strangeFileStringsSize__ = value; } }
        /// <summary>
        /// StrangeFileStringsOffset
        /// </summary>
        public int StrangeFileStringsOffset { get { return __strangeFileStringsOffset__; } set { __strangeFileStringsOffset__ = value; } }
        /// <summary>
        /// StringsOffset128
        /// </summary>
        public int StringsOffset128 { get { return __stringsOffset128__; } set { __stringsOffset128__ = value; } }
        /// <summary>
        /// StringCount
        /// </summary>
        public int StringCount { get { return __stringCount__; } set { __stringCount__ = value; } }
        /// <summary>
        /// StringsSize
        /// </summary>
        public int StringsSize { get { return __stringsSize__; } set { __stringsSize__ = value; } }
        /// <summary>
        /// StringsIndex
        /// </summary>
        public int StringsIndex { get { return __stringsIndex__; } set { __stringsIndex__ = value; } }
        /// <summary>
        /// StringsOffset
        /// </summary>
        public int StringsOffset { get { return __stringsOffset__; } set { __stringsOffset__ = value; } }
        /// <summary>
        /// InternalName
        /// </summary>
        public string InternalName { get { return __internalName__; } set { __internalName__ = value; } }
        /// <summary>
        /// ScenarioName
        /// </summary>
        public string ScenarioName { get { return __scenarioName__; } set { __scenarioName__ = value; } }
        /// <summary>
        /// FileTableCount
        /// </summary>
        public int FileTableCount { get { return __fileTableCount__; } set { __fileTableCount__ = value; } }
        /// <summary>
        /// FileTableOffset
        /// </summary>
        public int FileTableOffset { get { return __fileTableOffset__; } set { __fileTableOffset__ = value; } }
        /// <summary>
        /// FileTableSize
        /// </summary>
        public int FileTableSize { get { return __fileTableSize__; } set { __fileTableSize__ = value; } }
        /// <summary>
        /// FileTableIndexOffset
        /// </summary>
        public int FileTableIndexOffset { get { return __fileTableIndexOffset__; } set { __fileTableIndexOffset__ = value; } }
        /// <summary>
        /// Checksum
        /// </summary>
        public int Checksum { get { return __checksum__; } set { __checksum__ = value; } }
        /// <summary>
        /// Foot
        /// </summary>
        public string Foot { get { return __foot__; } set { __foot__ = value; } }

        #endregion

        public Header(Map.Stream.MapStream map)
        {
            Head = map.Header.Head;
            Version = map.Header.Version;
            Filesize = map.Header.Filesize;
            IndexOffset = map.Header.IndexOffset;
            IndexSize = map.Header.IndexSize;
            MetaStart = map.Header.MetaStart;
            MetaSize = map.Header.MetaSize;
            NonRawSize = map.Header.NonRawSize;
            Origin = map.Header.Origin;
            BuildDate = map.Header.BuildDate;
            MapTypeInt = map.Header.MapTypeInt;
            MapType = (Data.Types.MapTypes)MapTypeInt;

            StrangeFileStringsSize = map.Header.StrangeFileStringsSize;
            StrangeFileStringsOffset = map.Header.StrangeFileStringsOffset;
            StringsOffset128 = map.Header.StringsOffset128;
            StringCount = map.Header.StringCount;
            StringsSize = map.Header.StringsSize;
            StringsIndex = map.Header.StringsIndex;
            StringsOffset = map.Header.StringsOffset;
            InternalName = map.Header.InternalName;
            ScenarioName = map.Header.ScenarioName;
            FileTableCount = map.Header.FileTableCount;
            FileTableOffset = map.Header.FileTableOffset;
            FileTableSize = map.Header.FileTableSize;
            FileTableIndexOffset = map.Header.FileTableIndexOffset;
            Checksum = map.Header.Checksum;
            Foot = map.Header.Foot;
        }
    }
}
