using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Data.Divisions
{
    public class Index
    {
        #region Instance Data
        private int __primaryMagicConstant__;
        private int __primaryMagic__;
        private int __tagInfoIndexPointer__;
        private int __tagInfoIndexOffset__;
        private int __scnrID__;
        private int __firstID__;
        private int __tagCount__;
        private string __tags__;
        private int __secondaryMagicConstant__;
        private int __secondaryMagic__;
        #endregion

        #region Accessors
        /// <summary>
        /// PrimaryMagicConstant
        /// </summary>
        public int PrimaryMagicConstant { get { return __primaryMagicConstant__; } set { __primaryMagicConstant__ = value; } }
        /// <summary>
        /// PrimaryMagic
        /// </summary>
        public int PrimaryMagic { get { return __primaryMagic__; } set { __primaryMagic__ = value; } }
        /// <summary>
        /// TagInfoIndexPointer
        /// </summary>
        public int TagInfoIndexPointer { get { return __tagInfoIndexPointer__; } set { __tagInfoIndexPointer__ = value; } }
        /// <summary>
        /// TagInfoIndexOffset
        /// </summary>
        public int TagInfoIndexOffset { get { return __tagInfoIndexOffset__; } set { __tagInfoIndexOffset__ = value; } }
        /// <summary>
        /// ScnrID
        /// </summary>
        public int ScnrID { get { return __scnrID__; } set { __scnrID__ = value; } }
        /// <summary>
        /// FirstID
        /// </summary>
        public int FirstID { get { return __firstID__; } set { __firstID__ = value; } }
        /// <summary>
        /// TagCount
        /// </summary>
        public int TagCount { get { return __tagCount__; } set { __tagCount__ = value; } }
        /// <summary>
        /// Tags
        /// </summary>
        public string Tags { get { return __tags__; } set { __tags__ = value; } }
        /// <summary>
        /// SecondaryMagicConstant
        /// </summary>
        public int SecondaryMagicConstant { get { return __secondaryMagicConstant__; } set { __secondaryMagicConstant__ = value; } }
        /// <summary>
        /// SecondaryMagic
        /// </summary>
        public int SecondaryMagic { get { return __secondaryMagic__; } set { __secondaryMagic__ = value; } }

        #endregion

        public Index(Map.Stream.MapStream map)
        {
            //math to get our primary magic :P
            PrimaryMagicConstant = map.Index.PrimaryMagicConstant;
            PrimaryMagic = map.Index.PrimaryMagic;

            //the objects index (the tags)
            TagInfoIndexPointer = map.Index.TagInfoIndexPointer;
            TagInfoIndexOffset = map.Index.TagInfoIndexOffset;

            //ident of the scnr tag
            ScnrID = map.Index.ScnrID;

            //the very first ID (norm 'matg' tag)
            FirstID = map.Index.FirstID;

            //the total amount of tags in the Map
            TagCount = map.Index.TagCount;

            // sgat
            Tags = map.Index.Tags;

            //constant is raw meta offset of matg tag
            SecondaryMagicConstant = map.Index.SecondaryMagicConstant;
            SecondaryMagic = map.Index.SecondaryMagic;
        }
    }
}
