using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;

namespace H2Forge.Map.Data.Divisions
{
    public class Tags
    {
        public SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>> Items = new SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>>();

        #region New
        public Tags(SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>> items)
        {
            Items = items;
        }

        public Tags(Map.Stream.MapStream map, bool FixSbspAndLtmp, System.Windows.Forms.ProgressBar probar)
        {
            Items = map.Tags.ReadTags(FixSbspAndLtmp, probar);
        }
        #endregion

        public Data.Types.Tag GetTag(int ID)
        {
            foreach (KeyValuePair<string, SortedDictionary<string, Data.Types.Tag>> TagClass in Items)
            {
                foreach (Data.Types.Tag Tagg in TagClass.Value.Values)
                {
                    if (Tagg.ID == ID) return Tagg;
                }
            }
            return null;
        }

        public Data.Types.Tag GetTag(string type, string path)
        {
            return Items[type][path];
        }

        public string GetTagPath(int ID)
        {
            foreach (KeyValuePair<string, SortedDictionary<string, Data.Types.Tag>> TagClass in Items)
            {
                foreach (string TagPath in TagClass.Value.Keys)
                {
                    if (Items[TagClass.Key][TagPath].ID == ID) return TagPath;
                }
            }
            return null;
        }

        public void SetTagPath(int ID, string newPath)
        {
            throw new Exception("Not Yet Implemented");
        }

        public TreeNode GetTreeNodeOfTag(string tagType)
        {
            if (Items.ContainsKey(tagType))
            {
                //the Itemsthat will contain the Types that will
                //contain the tags respectively
                TreeNode tnList1 = new TreeNode(tagType);
                //go through Types
                //make a new node for the type
                tnList1 = new TreeNode("[" + tagType + "]", 1, 1);

                //go through the tags
                foreach (KeyValuePair<string, Data.Types.Tag> Tagg in Items[tagType])
                {
                    tnList1.Nodes.Add(Tagg.Key, Tagg.Key, 2, 2); //add it
                }

                return tnList1; //return the now pop. list
            }
            else return new TreeNode("tagType");
        }

        public string[] StringArrayOf(string tagType)
        {
            if (Items.ContainsKey(tagType)) // then we load all the tags
            {
                //Itemsfor tags
                string[] tmpItems = new string[Items.Count];
                int i = 0;
                foreach (KeyValuePair<string, Data.Types.Tag> Tagg in Items[tagType])
                {
                    tmpItems[i] = Tagg.Key; //add it
                    i++;
                }

                return tmpItems; //return the list

            }
            else // we load the tag the user wants
            {
                return new string[0];
            }
        }

        public TreeNode GetTreeViewNodeOfMap(string NodeTitle)
        {
            TreeNode tempNode = new TreeNode(NodeTitle);

            foreach (KeyValuePair<string, SortedDictionary<string, Data.Types.Tag>> TagClass in Items)
            {
                tempNode.Nodes.Add(GetTreeNodeOfTag(TagClass.Key));
            }

            //Expand the TreeView
            tempNode.Expand();

            return tempNode;
        }
    }
}
