using System;
using System.Collections.Generic;
using System.Text;
using H2Forge.Map;

namespace H2Forge.Map.Data
{
    public class MapData
    {
        #region Instances
        private Divisions.Header __header__;
        private Divisions.Index __index__;
        private Divisions.Tags __tags__;
        private Divisions.Sbsp __sbsp__;
        private Divisions.Strings __strings__;
        #endregion

        #region Accessors
        /// <summary>
        /// Halo 2 Map Header
        /// </summary>
        public Divisions.Header Header { get { return __header__; } set { __header__ = value; } }
        /// <summary>
        /// Halo 2 Map Index
        /// </summary>
        public Divisions.Index Index { get { return __index__; } set { __index__ = value; } }
        /// <summary>
        /// Halo 2 Map Tags
        /// </summary>
        public Divisions.Tags Tags { get { return __tags__; } set { __tags__ = value; } }
        /// <summary>
        /// Halo 2 Map Sbsp
        /// </summary>
        public Divisions.Sbsp Sbsp { get { return __sbsp__; } set { __sbsp__ = value; } }
        /// <summary>
        /// Halo 2 Map Strings
        /// </summary>
        public Divisions.Strings Strings { get { return __strings__; } set { __strings__ = value; } }
        #endregion

        public MapData()
        { }

        public MapData(Stream.MapStream mapStream, System.Windows.Forms.ProgressBar probar)
        {
            Header = new Divisions.Header(mapStream);
            Index = new Divisions.Index(mapStream);
            Sbsp = new Divisions.Sbsp(mapStream);
            Tags = new Divisions.Tags(mapStream, mapStream.SbspAndLtmpInfoIsFixed, probar);
            Strings = new Divisions.Strings(mapStream);
        }
    }
}
