using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Data.Types
{
    public class Bitmask
    {
        #region Instances
        private bool[] __bits;
        #endregion

        #region Accessors
        public bool[] Bits { get { return __bits; } set { __bits = value; } }
        #endregion

        public Bitmask(byte[] Bytes)
        {
            Bits = ConvertToBoolArray(Bytes);
        }

        /// <summary>
        /// Converts An Array Of Bytes To An Array Bits As Booleans
        /// </summary>
        /// <param name="Bytes"></param>
        /// <returns></returns>
        public static bool[] ConvertToBoolArray(byte[] Bytes)
        {
            bool[] bitArray = new bool[Bytes.Length * 8];
            int input;
            int bittester;

            for (int i = 0; i < Bytes.Length; i++)
            {
                input = BitConverter.ToInt16(new byte[2] { Bytes[i], 0 }, 0);
                bittester = 1;

                for (int counter = 0; counter < 8; counter++)
                {
                    bitArray[i + counter] = (input & bittester) > 0 ? true : false;
                    bittester *= 2;
                }
            }

            return bitArray;
        }

        public static byte[] ConvertToByteArray(bool[] Bits)
        {
            int ByteCount = Bits.Length / 8;
            int BitData;
            BitData = 0;

            for (int z = 0; z < Bits.Length; z++)
            {
                BitData = setBit(BitData, z, Bits[z]);
            }

            byte[] AllBytes = BitConverter.GetBytes(BitData);
            byte[] ReturnBytes = new byte[ByteCount];

            for (int i = 0; i < ByteCount; i++)
            {
                ReturnBytes[i] = AllBytes[i];
            }

            return ReturnBytes;
        }

        private static int setBit(int integer, int bitIndex, bool onOff)
        {
            if (onOff == true)
            {
                integer = (1 << bitIndex) | integer;
            }
            else
            {
                integer = ~(1 << bitIndex) & integer;
            }
            return integer;
        }
    }
}
