using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Stream.Divisions
{
    public class Index
    {
        #region Instances
        private MapStream __mapStream;
        #endregion

        #region Accessors
        private MapStream ParentMapStream { get { return __mapStream; } }
        #endregion

        #region Data
        /// <summary>
        /// Read Or Write PrimaryMagicConstant
        /// </summary>
        public int PrimaryMagicConstant { get { return ParentMapStream.ReadInt32At(ParentMapStream.IndexOffset, false); } set { ParentMapStream.WriteAt(ParentMapStream.IndexOffset, value, false); } }
        /// <summary>
        /// Calculate PrimaryMagic
        /// </summary>
        public int PrimaryMagic { get { return PrimaryMagicConstant - (ParentMapStream.IndexOffset + 32); } }
        /// <summary>
        /// Read Or Write TagInfoIndexPointer
        /// </summary>
        public int TagInfoIndexPointer { get { return ParentMapStream.ReadInt32At(ParentMapStream.IndexOffset + 8, false); } set { ParentMapStream.WriteAt(ParentMapStream.IndexOffset + 8, value, false); } }
        /// <summary>
        /// Calculate TagInfoIndexOffset
        /// </summary>
        public int TagInfoIndexOffset { get { return TagInfoIndexPointer - PrimaryMagic; } }
        /// <summary>
        /// Read Or Write ScnrID
        /// </summary>
        public int ScnrID { get { return ParentMapStream.ReadInt32At(ParentMapStream.IndexOffset + 12, false); } set { ParentMapStream.WriteAt(ParentMapStream.IndexOffset + 12, value, false); ParentMapStream.Scnr.ID = value; } }
        /// <summary>
        /// Read Or Write FirstID
        /// </summary>
        public int FirstID { get { return ParentMapStream.ReadInt32At(ParentMapStream.IndexOffset + 16, false); } set { ParentMapStream.WriteAt(ParentMapStream.IndexOffset + 16, value, false); } }
        /// <summary>
        /// Read Or Write TagCount
        /// </summary>
        public int TagCount { get { return ParentMapStream.ReadInt32At(ParentMapStream.IndexOffset + 24, false); } set { ParentMapStream.WriteAt(ParentMapStream.IndexOffset + 24, value, false); ParentMapStream.TagInfoCount = value; } }
        /// <summary>
        /// Read Or Write Tags
        /// </summary>
        public string Tags { get { return ParentMapStream.ReadStringAt(ParentMapStream.IndexOffset + 28, 4, false, false); } set { ParentMapStream.WriteAt(ParentMapStream.IndexOffset + 28, value, false); } }
        /// <summary>
        /// Read Or Write SecondaryMagicConstant
        /// </summary>
        public int SecondaryMagicConstant { get { return ParentMapStream.ReadInt32At(ParentMapStream.TagInfoIndexOffset + 8, false); } set { ParentMapStream.WriteAt(ParentMapStream.TagInfoIndexOffset + 8, value, false); ParentMapStream.SecondaryMagic = value; } }
        /// <summary>
        /// Calculate SecondaryMagic
        /// </summary>
        public int SecondaryMagic { get { return SecondaryMagicConstant - ParentMapStream.Header.MetaStart; } }
        #endregion

        #region New
        public Index(MapStream mapStream)
        {
            __mapStream = mapStream;
            mapStream.SecondaryMagic = SecondaryMagic;
            mapStream.TagInfoIndexOffset = TagInfoIndexOffset;
            mapStream.TagInfoCount = TagCount;
        }
        #endregion
    }
}
