using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Stream.Divisions
{
    public class LightMap
    {        
        #region Instances
        private int __startOffset;
        private int __sbspInfoIndex;
        private MapStream __mapStream;
        #endregion

        #region Accessors
        /// <summary>
        /// Start Offset
        /// </summary>
        public int StartOffset { get { return __startOffset; } set { __startOffset = value; } }
        public int SbspInfoIndex { get { return __sbspInfoIndex; } }
        private MapStream ParentMapStream { get { return __mapStream; } }
        #endregion

        #region Data
        /// <summary>
        /// Read ID
        /// </summary>
        public int ID { get { return ParentMapStream.ReadInt32At(ParentMapStream.SbspInfoList[SbspInfoIndex].StartOffset + 20, false); } set { ParentMapStream.WriteAt(ParentMapStream.SbspInfoList[SbspInfoIndex].StartOffset + 20, value, false); } }
        /// <summary>
        /// Read TagPath
        /// </summary>
        public string TagPath { get { return ParentMapStream.Tags.ReadTagPath(ID); } }
        /// <summary>
        /// Read Offset
        /// </summary>
        public int Offset { get { return ParentMapStream.ReadInt32At(ParentMapStream.SbspInfoList[SbspInfoIndex].MetaOffset + 8, false) - ParentMapStream.SbspInfoList[SbspInfoIndex].Magic; } set { ParentMapStream.WriteAt(ParentMapStream.SbspInfoList[SbspInfoIndex].StartOffset + 24, value + ParentMapStream.SbspInfoList[SbspInfoIndex].Magic, false); } }
        /// <summary>
        /// Calculate Size
        /// </summary>
        public int Size { get { return (ParentMapStream.SbspInfoList[SbspInfoIndex].MetaOffset + ParentMapStream.SbspInfoList[SbspInfoIndex].MetaSize) - Offset; } }
        ///// <summary>
        ///// PalettesOffset
        ///// </summary>
        //public int PalettesOffset { get { return __palettesOffset__; } set { __palettesOffset__ = value; } }
        ///// <summary>
        ///// Palettes
        ///// </summary>
        //public List<PaletteColor[]> Palettes { get { return __palettes__; } set { WritePalettes(value); } }
        ///// <summary>
        ///// Bsp_Submap_Indices
        ///// </summary>
        //public int[] Bsp_Submap_Indices { get { return __bsp_Submap_Indices__; } set { __bsp_Submap_Indices__ = value; } }
        ///// <summary>
        ///// Bsp_Palette_Indices
        ///// </summary>
        //public int[] Bsp_Palette_Indices { get { return __bsp_Palette_Indices__; } set { __bsp_Palette_Indices__ = value; } }
        ///// <summary>
        ///// Perm_Submap_Indices
        ///// </summary>
        //public int[] Perm_Submap_Indices { get { return __perm_Submap_Indices__; } set { __perm_Submap_Indices__ = value; } }
        ///// <summary>
        ///// Perm_Palette_Indices
        ///// </summary>
        //public int[] Perm_Palette_Indices { get { return __perm_Palette_Indices__; } set { __perm_Palette_Indices__ = value; } }

        #endregion

        public LightMap(MapStream mapStream, int sbspInfoIndex)
        {
            __mapStream = mapStream;
            __sbspInfoIndex = sbspInfoIndex;
        }

        //private void WritePalettes(List<PaletteColor[]> palettes)
        //{
        //    ParentMapStream.Position = this.PalettesOffset;
        //    foreach (PaletteColor[] pal in palettes)
        //    {
        //        for (int x = 0; x < 256; x++)
        //        {
        //            ParentMapStream.Write((byte)pal[x].r);
        //            ParentMapStream.Write((byte)pal[x].g);
        //            ParentMapStream.Write((byte)pal[x].b);
        //            ParentMapStream.Write((byte)pal[x].a);
        //        }
        //    }
        //}

        //public struct PaletteColor
        //{
        //    public int a, r, g, b;
        //}
    }
}
