using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Stream.Divisions
{
    public class Strings
    {
        #region Instances
        private MapStream __mapStream;
        #endregion

        #region Accessors
        private MapStream ParentMapStream { get { return __mapStream; } }
        #endregion

        public Strings(MapStream mapStream)
        {
            __mapStream = mapStream;
        }

        public List<Map.Data.Types.StringTableString> ReadTable()
        {
            List<Map.Data.Types.StringTableString> strings = new List<Map.Data.Types.StringTableString>();
            int count = ParentMapStream.Header.StringCount;
            ParentMapStream.Position = ParentMapStream.Header.StringsOffset;

            //and gather the strings
            for (int x = 0; x < count; x++)
                strings.Add(new Map.Data.Types.StringTableString(ParentMapStream.ReadNullTerminatedString(), 0));

            ParentMapStream.Position = ParentMapStream.Header.StringsIndex;

            //gather the offsets
            for (int x = 0; x < count; x++)
            {
                strings[x].Offset = ParentMapStream.Header.StringsOffset + ParentMapStream.ReadInt32();
            }

            return strings;
        }

        public void WriteTable(List<Map.Data.Types.StringTableString> table)
        {
            for (int i = 0; i < table.Count; i++)
            {
                ParentMapStream.WriteReverseStringAt(table[i].Offset, table[i].String, false);
            }
        }

        public void WriteString(Map.Data.Types.StringTableString STS)
        {
            ParentMapStream.WriteReverseStringAt(STS.Offset, STS.String, false);
        }
    }
}
