using System;
using System.Collections.Generic;
using System.Text;

namespace H2Forge.Map.Stream.Divisions
{
    public class Tags
    {
        #region Instances
        private MapStream __mapStream;
        #endregion

        #region Accessors
        private MapStream ParentMapStream { get { return __mapStream; } }
        #endregion

        #region Data
        public SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>> ReadTags(bool FixSbspAndLtmp, System.Windows.Forms.ProgressBar probar)
        {
            probar.Minimum = 0;
            probar.Maximum = ParentMapStream.TagInfoCount * 3;
            probar.Value = 0;
            
            //will store the tags of the Map
            string[] classList = new string[ParentMapStream.TagInfoCount];
            string[] pathList = new string[ParentMapStream.TagInfoCount];
            SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>> Items = new SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>>();

            ParentMapStream.Position = ParentMapStream.TagInfoIndexOffset;

            //count through the 'said' tag amount
            for (int x = 0; x < ParentMapStream.TagInfoCount; x++)
            {
                //this is the tagtype, they are backward in Map so we reverse
                //and this is the rest of the info
                classList[x] = ParentMapStream.ReadReverseString(4, false);
                ParentMapStream.Position += 12;
                if (!Items.ContainsKey(classList[x])) Items.Add(classList[x], new SortedDictionary<string, Data.Types.Tag>());
                probar.Value++;
                System.Windows.Forms.Application.DoEvents();
            }

            //go to the filetable which contains all the strings - globals/globals etc
            ParentMapStream.Position = ParentMapStream.Header.FileTableOffset;

            //go through the tags and add in their paths
            for (int x = 0; x < ParentMapStream.TagInfoCount; x++)
            {
                pathList[x] = ParentMapStream.ReadNullTerminatedString();
                Items[classList[x]].Add(pathList[x], new Data.Types.Tag());
                Items[classList[x]][pathList[x]].PathLength = pathList[x].Length;
                Items[classList[x]][pathList[x]].PathOffset = (int)ParentMapStream.Position - pathList[x].Length;
                probar.Value++;
                System.Windows.Forms.Application.DoEvents();
            }

            ParentMapStream.Position = ParentMapStream.TagInfoIndexOffset;
            for (int x = 0; x < ParentMapStream.TagInfoCount; x++)
            {
                ParentMapStream.Position += 4;
                Items[classList[x]][pathList[x]].ID = ParentMapStream.ReadInt32();
                Items[classList[x]][pathList[x]].RawMetaOffset = ParentMapStream.ReadInt32();
                Items[classList[x]][pathList[x]].Offset = Items[classList[x]][pathList[x]].RawMetaOffset - ParentMapStream.Index.SecondaryMagic;
                Items[classList[x]][pathList[x]].Size = ParentMapStream.ReadInt32();
                probar.Value++;
                System.Windows.Forms.Application.DoEvents();
            }

            if (FixSbspAndLtmp)
            {
                //##temp
                ParentMapStream.__sbspAndLtmpInfoIsFixed__ = false;
                throw new Exception("Sbsp And Ltmp Correction Not Yet Implemented");
                //##

                //Items["sbsp"] = ParentMapStream.SbspTags;
                //foreach (KeyValuePair<string, LightMap> ltmp in ParentMapStream.LightMapTags)
                //{
                //    Items["ltmp"][ltmp.Key].Offset = ltmp.Value.Offset;
                //    Items["ltmp"][ltmp.Key].Size = ltmp.Value.Size;
                //}
            }
            return Items;
        }

        public void WriteTag(Data.Types.Tag Tag)
        { 
            
        }

        public Data.Types.Tag ReadTag(int ID)
        {
            ParentMapStream.Position = ParentMapStream.TagInfoIndexOffset;
            Data.Types.Tag tempTag = null;
            int IDTest;
            //count through the 'said' tag amount
            for (int x = 0; x < ParentMapStream.TagInfoCount; x++)
            {
                ParentMapStream.Position += 4;
                IDTest = ParentMapStream.ReadInt32();
                if (IDTest == ID)
                {
                    tempTag = new H2Forge.Map.Data.Types.Tag();
                    tempTag.ID = IDTest;
                    tempTag.RawMetaOffset = ParentMapStream.ReadInt32();
                    tempTag.Offset = tempTag.RawMetaOffset - ParentMapStream.SecondaryMagic;
                    tempTag.Size = ParentMapStream.ReadInt32();
                    break;
                }
                ParentMapStream.Position += 8;
            }

            return tempTag;
        }

        public string ReadTagPath(int ID)
        {
            ParentMapStream.Position = ParentMapStream.TagInfoIndexOffset;
            int index = -1;
            int tempindex;
            //count through the 'said' tag amount
            for (int x = 0; x < ParentMapStream.TagInfoCount; x++)
            {
                ParentMapStream.Position += 4;
                tempindex = ParentMapStream.ReadInt32();
                if (tempindex == ID)
                {
                    index = tempindex;
                    break;
                }
                ParentMapStream.Position += 8;
            }

            if (index == -1) return null;

            //go to the filetable which contains all the strings - globals/globals etc
            ParentMapStream.Position = ParentMapStream.FileTableOffset;
            string temppath = null;
            //go through the tags and add in their paths
            for (int x = 0; x <= index; x++)
            {
                temppath = ParentMapStream.ReadNullTerminatedString();
            }

            return temppath;
        }

        public void WriteTagPath(int ID, string newPath)
        { 

        }
        #endregion

        public Tags(MapStream mapStream, bool FixSbspAndLtmp)
        {
            __mapStream = mapStream;
            //SortedDictionary<string, SortedDictionary<string, Data.Types.Tag>> tags = ReadTags(FixSbspAndLtmp);
            //ParentMapStream.SbspTags = tags["sbsp"];

            //foreach (KeyValuePair<string, Data.Types.Tag> ltmp in tags["ltmp"])
            //{
            //    ParentMapStream.LightMapTags.Add(ltmp.Key, new LightMap(ParentMapStream, ltmp.Value.Offset));
            //}
        }
    }
}
